// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package bedrockruntime

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeAccessDeniedException for service response error code
	// "AccessDeniedException".
	//
	// The request is denied because of missing access permissions.
	ErrCodeAccessDeniedException = "AccessDeniedException"

	// ErrCodeInternalServerException for service response error code
	// "InternalServerException".
	//
	// An internal server error occurred. Retry your request.
	ErrCodeInternalServerException = "InternalServerException"

	// ErrCodeModelErrorException for service response error code
	// "ModelErrorException".
	//
	// The request failed due to an error while processing the model.
	ErrCodeModelErrorException = "ModelErrorException"

	// ErrCodeModelNotReadyException for service response error code
	// "ModelNotReadyException".
	//
	// The model specified in the request is not ready to serve inference requests.
	ErrCodeModelNotReadyException = "ModelNotReadyException"

	// ErrCodeModelStreamErrorException for service response error code
	// "ModelStreamErrorException".
	//
	// An error occurred while streaming the response. Retry your request.
	ErrCodeModelStreamErrorException = "ModelStreamErrorException"

	// ErrCodeModelTimeoutException for service response error code
	// "ModelTimeoutException".
	//
	// The request took too long to process. Processing time exceeded the model
	// timeout length.
	ErrCodeModelTimeoutException = "ModelTimeoutException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The specified resource ARN was not found. Check the ARN and try your request
	// again.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeServiceQuotaExceededException for service response error code
	// "ServiceQuotaExceededException".
	//
	// Your request exceeds the service quota for your account. You can view your
	// quotas at Viewing service quotas (https://docs.aws.amazon.com/servicequotas/latest/userguide/gs-request-quota.html).
	// You can resubmit your request later.
	ErrCodeServiceQuotaExceededException = "ServiceQuotaExceededException"

	// ErrCodeServiceUnavailableException for service response error code
	// "ServiceUnavailableException".
	//
	// The service isn't currently available. Try again later.
	ErrCodeServiceUnavailableException = "ServiceUnavailableException"

	// ErrCodeThrottlingException for service response error code
	// "ThrottlingException".
	//
	// Your request was throttled because of service-wide limitations. Resubmit
	// your request later or in a different region. You can also purchase Provisioned
	// Throughput (https://docs.aws.amazon.com/bedrock/latest/userguide/prov-throughput.html)
	// to increase the rate or number of tokens you can process.
	ErrCodeThrottlingException = "ThrottlingException"

	// ErrCodeValidationException for service response error code
	// "ValidationException".
	//
	// Input validation failed. Check your request parameters and retry the request.
	ErrCodeValidationException = "ValidationException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"AccessDeniedException":         newErrorAccessDeniedException,
	"InternalServerException":       newErrorInternalServerException,
	"ModelErrorException":           newErrorModelErrorException,
	"ModelNotReadyException":        newErrorModelNotReadyException,
	"ModelStreamErrorException":     newErrorModelStreamErrorException,
	"ModelTimeoutException":         newErrorModelTimeoutException,
	"ResourceNotFoundException":     newErrorResourceNotFoundException,
	"ServiceQuotaExceededException": newErrorServiceQuotaExceededException,
	"ServiceUnavailableException":   newErrorServiceUnavailableException,
	"ThrottlingException":           newErrorThrottlingException,
	"ValidationException":           newErrorValidationException,
}
